<html>
<head>
<title>OgreBitwise.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreBitwise.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreBitwise_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _Bitwise_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _Bitwise_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>Ogre {
<a name="l00043"></a><a class="code" href="classOgre_1_1Bitwise.html">00043</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1Bitwise.html" title="Class for manipulating bit patterns.">Bitwise</a> {
<a name="l00044"></a>00044     <span class="keyword">public</span>:
<a name="l00047"></a><a class="code" href="classOgre_1_1Bitwise.html#aa3fd3a659f416fe2f6e034c42b6a873c">00047</a>         <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1Bitwise.html#aa3fd3a659f416fe2f6e034c42b6a873c" title="Returns the most significant bit set in a value.">mostSignificantBitSet</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> value)
<a name="l00048"></a>00048         {
<a name="l00049"></a>00049             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> result = 0;
<a name="l00050"></a>00050             <span class="keywordflow">while</span> (value != 0) {
<a name="l00051"></a>00051                 ++result;
<a name="l00052"></a>00052                 value &gt;&gt;= 1;
<a name="l00053"></a>00053             }
<a name="l00054"></a>00054             <span class="keywordflow">return</span> result-1;
<a name="l00055"></a>00055         }
<a name="l00060"></a><a class="code" href="classOgre_1_1Bitwise.html#af1d86f2723f835a233138259c962a952">00060</a>         <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1Bitwise.html#af1d86f2723f835a233138259c962a952" title="Returns the closest power-of-two number greater or equal to value.">firstPO2From</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> n)
<a name="l00061"></a>00061         {
<a name="l00062"></a>00062             --n;            
<a name="l00063"></a>00063             n |= n &gt;&gt; 16;
<a name="l00064"></a>00064             n |= n &gt;&gt; 8;
<a name="l00065"></a>00065             n |= n &gt;&gt; 4;
<a name="l00066"></a>00066             n |= n &gt;&gt; 2;
<a name="l00067"></a>00067             n |= n &gt;&gt; 1;
<a name="l00068"></a>00068             ++n;
<a name="l00069"></a>00069             <span class="keywordflow">return</span> n;
<a name="l00070"></a>00070         }
<a name="l00074"></a>00074         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00075"></a><a class="code" href="classOgre_1_1Bitwise.html#acef0757b2a07e5b297c87247f38f1691">00075</a>         <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Bitwise.html#acef0757b2a07e5b297c87247f38f1691" title="Determines whether the number is power-of-two or not.">isPO2</a>(T n)
<a name="l00076"></a>00076         {
<a name="l00077"></a>00077             <span class="keywordflow">return</span> (n &amp; (n-1)) == 0;
<a name="l00078"></a>00078         }
<a name="l00082"></a>00082         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00083"></a><a class="code" href="classOgre_1_1Bitwise.html#a60bde1c399a387326753a52f9d56939c">00083</a>         <span class="keyword">static</span> <a class="code" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1Bitwise.html#a60bde1c399a387326753a52f9d56939c" title="Returns the number of bits a pattern must be shifted right by to remove right-hand zeros...">getBitShift</a>(T mask)
<a name="l00084"></a>00084         {
<a name="l00085"></a>00085             <span class="keywordflow">if</span> (mask == 0)
<a name="l00086"></a>00086                 <span class="keywordflow">return</span> 0;
<a name="l00087"></a>00087 
<a name="l00088"></a>00088             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> result = 0;
<a name="l00089"></a>00089             <span class="keywordflow">while</span> ((mask &amp; 1) == 0) {
<a name="l00090"></a>00090                 ++result;
<a name="l00091"></a>00091                 mask &gt;&gt;= 1;
<a name="l00092"></a>00092             }
<a name="l00093"></a>00093             <span class="keywordflow">return</span> result;
<a name="l00094"></a>00094         }
<a name="l00095"></a>00095 
<a name="l00101"></a>00101         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> SrcT, <span class="keyword">typename</span> DestT&gt;
<a name="l00102"></a><a class="code" href="classOgre_1_1Bitwise.html#a65c7e2d0a2b2278e58450bb9d289e148">00102</a>         <span class="keyword">static</span> <span class="keyword">inline</span> DestT <a class="code" href="classOgre_1_1Bitwise.html#a65c7e2d0a2b2278e58450bb9d289e148" title="Takes a value with a given src bit mask, and produces another value with a desired bit mask...">convertBitPattern</a>(SrcT srcValue, SrcT srcBitMask, DestT destBitMask)
<a name="l00103"></a>00103         {
<a name="l00104"></a>00104             <span class="comment">// Mask off irrelevant source value bits (if any)</span>
<a name="l00105"></a>00105             srcValue = srcValue &amp; srcBitMask;
<a name="l00106"></a>00106 
<a name="l00107"></a>00107             <span class="comment">// Shift source down to bottom of DWORD</span>
<a name="l00108"></a>00108             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> srcBitShift = <a class="code" href="classOgre_1_1Bitwise.html#a60bde1c399a387326753a52f9d56939c" title="Returns the number of bits a pattern must be shifted right by to remove right-hand zeros...">getBitShift</a>(srcBitMask);
<a name="l00109"></a>00109             srcValue &gt;&gt;= srcBitShift;
<a name="l00110"></a>00110 
<a name="l00111"></a>00111             <span class="comment">// Get max value possible in source from srcMask</span>
<a name="l00112"></a>00112             <span class="keyword">const</span> SrcT srcMax = srcBitMask &gt;&gt; srcBitShift;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114             <span class="comment">// Get max available in dest</span>
<a name="l00115"></a>00115             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> destBitShift = <a class="code" href="classOgre_1_1Bitwise.html#a60bde1c399a387326753a52f9d56939c" title="Returns the number of bits a pattern must be shifted right by to remove right-hand zeros...">getBitShift</a>(destBitMask);
<a name="l00116"></a>00116             <span class="keyword">const</span> DestT destMax = destBitMask &gt;&gt; destBitShift;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118             <span class="comment">// Scale source value into destination, and shift back</span>
<a name="l00119"></a>00119             DestT destValue = (srcValue * destMax) / srcMax;
<a name="l00120"></a>00120             <span class="keywordflow">return</span> (destValue &lt;&lt; destBitShift);
<a name="l00121"></a>00121         }
<a name="l00122"></a>00122 
<a name="l00127"></a><a class="code" href="classOgre_1_1Bitwise.html#aa59b3726641c31b63aa3e203559ca3bd">00127</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1Bitwise.html#aa59b3726641c31b63aa3e203559ca3bd" title="Convert N bit colour channel value to P bits.">fixedToFixed</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> value, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p) 
<a name="l00128"></a>00128         {
<a name="l00129"></a>00129             <span class="keywordflow">if</span>(n &gt; p) 
<a name="l00130"></a>00130             {
<a name="l00131"></a>00131                 <span class="comment">// Less bits required than available; this is easy</span>
<a name="l00132"></a>00132                 value &gt;&gt;= n-p;
<a name="l00133"></a>00133             } 
<a name="l00134"></a>00134             <span class="keywordflow">else</span> <span class="keywordflow">if</span>(n &lt; p)
<a name="l00135"></a>00135             {
<a name="l00136"></a>00136                 <span class="comment">// More bits required than are there, do the fill</span>
<a name="l00137"></a>00137                 <span class="comment">// Use old fashioned division, probably better than a loop</span>
<a name="l00138"></a>00138                 <span class="keywordflow">if</span>(value == 0)
<a name="l00139"></a>00139                         value = 0;
<a name="l00140"></a>00140                 <span class="keywordflow">else</span> <span class="keywordflow">if</span>(value == (static_cast&lt;unsigned int&gt;(1)&lt;&lt;n)-1)
<a name="l00141"></a>00141                         value = (1&lt;&lt;p)-1;
<a name="l00142"></a>00142                 <span class="keywordflow">else</span>    value = value*(1&lt;&lt;p)/((1&lt;&lt;n)-1);
<a name="l00143"></a>00143             }
<a name="l00144"></a>00144             <span class="keywordflow">return</span> value;    
<a name="l00145"></a>00145         }
<a name="l00146"></a>00146 
<a name="l00151"></a><a class="code" href="classOgre_1_1Bitwise.html#ad3f4d30ecc1aa5ea112a38e63a47b9c8">00151</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1Bitwise.html#ad3f4d30ecc1aa5ea112a38e63a47b9c8" title="Convert floating point colour channel value between 0.0 and 1.0 (otherwise clamped) to integer of a c...">floatToFixed</a>(<span class="keyword">const</span> <span class="keywordtype">float</span> value, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bits)
<a name="l00152"></a>00152         {
<a name="l00153"></a>00153             <span class="keywordflow">if</span>(value &lt;= 0.0f) <span class="keywordflow">return</span> 0;
<a name="l00154"></a>00154             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (value &gt;= 1.0f) <span class="keywordflow">return</span> (1&lt;&lt;bits)-1;
<a name="l00155"></a>00155             <span class="keywordflow">else</span> <span class="keywordflow">return</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)(value * (1&lt;&lt;bits));     
<a name="l00156"></a>00156         }
<a name="l00157"></a>00157 
<a name="l00161"></a><a class="code" href="classOgre_1_1Bitwise.html#a48006ba79d6f8c690e3131c7b4e441bf">00161</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1Bitwise.html#a48006ba79d6f8c690e3131c7b4e441bf" title="Fixed point to float.">fixedToFloat</a>(<span class="keywordtype">unsigned</span> value, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bits)
<a name="l00162"></a>00162         {
<a name="l00163"></a>00163             <span class="keywordflow">return</span> (<span class="keywordtype">float</span>)value/(float)((1&lt;&lt;bits)-1);
<a name="l00164"></a>00164         }
<a name="l00165"></a>00165 
<a name="l00169"></a><a class="code" href="classOgre_1_1Bitwise.html#afa88e9d32bbc468ac3ee803ee4228ca1">00169</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Bitwise.html#afa88e9d32bbc468ac3ee803ee4228ca1" title="Write a n*8 bits integer value to memory in native endian.">intWrite</a>(<span class="keywordtype">void</span> *dest, <span class="keyword">const</span> <span class="keywordtype">int</span> n, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> value)
<a name="l00170"></a>00170         {
<a name="l00171"></a>00171             <span class="keywordflow">switch</span>(n) {
<a name="l00172"></a>00172                 <span class="keywordflow">case</span> 1:
<a name="l00173"></a>00173                     ((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)dest)[0] = (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>)value;
<a name="l00174"></a>00174                     <span class="keywordflow">break</span>;
<a name="l00175"></a>00175                 <span class="keywordflow">case</span> 2:
<a name="l00176"></a>00176                     ((<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>*)dest)[0] = (<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>)value;
<a name="l00177"></a>00177                     <span class="keywordflow">break</span>;
<a name="l00178"></a>00178                 <span class="keywordflow">case</span> 3:
<a name="l00179"></a>00179 <span class="preprocessor">#if OGRE_ENDIAN == OGRE_ENDIAN_BIG      </span>
<a name="l00180"></a>00180 <span class="preprocessor"></span>                    ((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)dest)[0] = (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>)((value &gt;&gt; 16) &amp; 0xFF);
<a name="l00181"></a>00181                     ((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)dest)[1] = (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>)((value &gt;&gt; 8) &amp; 0xFF);
<a name="l00182"></a>00182                     ((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)dest)[2] = (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>)(value &amp; 0xFF);
<a name="l00183"></a>00183 <span class="preprocessor">#else</span>
<a name="l00184"></a>00184 <span class="preprocessor"></span>                    ((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)dest)[2] = (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>)((value &gt;&gt; 16) &amp; 0xFF);
<a name="l00185"></a>00185                     ((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)dest)[1] = (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>)((value &gt;&gt; 8) &amp; 0xFF);
<a name="l00186"></a>00186                     ((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)dest)[0] = (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>)(value &amp; 0xFF);
<a name="l00187"></a>00187 <span class="preprocessor">#endif</span>
<a name="l00188"></a>00188 <span class="preprocessor"></span>                    <span class="keywordflow">break</span>;
<a name="l00189"></a>00189                 <span class="keywordflow">case</span> 4:
<a name="l00190"></a>00190                     ((<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>*)dest)[0] = (<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>)value;                
<a name="l00191"></a>00191                     <span class="keywordflow">break</span>;                
<a name="l00192"></a>00192             }        
<a name="l00193"></a>00193         }
<a name="l00197"></a><a class="code" href="classOgre_1_1Bitwise.html#ad0fcaa2e4f445d1e9c1fb69291061dec">00197</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1Bitwise.html#ad0fcaa2e4f445d1e9c1fb69291061dec" title="Read a n*8 bits integer value to memory in native endian.">intRead</a>(<span class="keyword">const</span> <span class="keywordtype">void</span> *src, <span class="keywordtype">int</span> n) {
<a name="l00198"></a>00198             <span class="keywordflow">switch</span>(n) {
<a name="l00199"></a>00199                 <span class="keywordflow">case</span> 1:
<a name="l00200"></a>00200                     <span class="keywordflow">return</span> ((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)src)[0];
<a name="l00201"></a>00201                 <span class="keywordflow">case</span> 2:
<a name="l00202"></a>00202                     <span class="keywordflow">return</span> ((<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>*)src)[0];
<a name="l00203"></a>00203                 <span class="keywordflow">case</span> 3:
<a name="l00204"></a>00204 <span class="preprocessor">#if OGRE_ENDIAN == OGRE_ENDIAN_BIG      </span>
<a name="l00205"></a>00205 <span class="preprocessor"></span>                    <span class="keywordflow">return</span> ((<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>)((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)src)[0]&lt;&lt;16)|
<a name="l00206"></a>00206                             ((<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>)((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)src)[1]&lt;&lt;8)|
<a name="l00207"></a>00207                             ((<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>)((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)src)[2]);
<a name="l00208"></a>00208 <span class="preprocessor">#else</span>
<a name="l00209"></a>00209 <span class="preprocessor"></span>                    <span class="keywordflow">return</span> ((<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>)((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)src)[0])|
<a name="l00210"></a>00210                             ((<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>)((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)src)[1]&lt;&lt;8)|
<a name="l00211"></a>00211                             ((<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>)((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>*)src)[2]&lt;&lt;16);
<a name="l00212"></a>00212 <span class="preprocessor">#endif</span>
<a name="l00213"></a>00213 <span class="preprocessor"></span>                <span class="keywordflow">case</span> 4:
<a name="l00214"></a>00214                     <span class="keywordflow">return</span> ((<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>*)src)[0];
<a name="l00215"></a>00215             } 
<a name="l00216"></a>00216             <span class="keywordflow">return</span> 0; <span class="comment">// ?</span>
<a name="l00217"></a>00217         }
<a name="l00218"></a>00218 
<a name="l00222"></a><a class="code" href="classOgre_1_1Bitwise.html#aa02a9c5a117baf2da38ad562c2130681">00222</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1Bitwise.html#aa02a9c5a117baf2da38ad562c2130681" title="Convert a float32 to a float16 (NV_half_float) Courtesy of OpenEXR.">floatToHalf</a>(<span class="keywordtype">float</span> i)
<a name="l00223"></a>00223         {
<a name="l00224"></a>00224             <span class="keyword">union </span>{ <span class="keywordtype">float</span> f; <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> i; } v;
<a name="l00225"></a>00225             v.f = i;
<a name="l00226"></a>00226             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Bitwise.html#ad98268f6e1288301c0471e345e98cd1e" title="Converts float in uint32 format to a a half in uint16 format.">floatToHalfI</a>(v.i);
<a name="l00227"></a>00227         }
<a name="l00230"></a><a class="code" href="classOgre_1_1Bitwise.html#ad98268f6e1288301c0471e345e98cd1e">00230</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1Bitwise.html#ad98268f6e1288301c0471e345e98cd1e" title="Converts float in uint32 format to a a half in uint16 format.">floatToHalfI</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> i)
<a name="l00231"></a>00231         {
<a name="l00232"></a>00232             <span class="keyword">register</span> <span class="keywordtype">int</span> s =  (i &gt;&gt; 16) &amp; 0x00008000;
<a name="l00233"></a>00233             <span class="keyword">register</span> <span class="keywordtype">int</span> e = ((i &gt;&gt; 23) &amp; 0x000000ff) - (127 - 15);
<a name="l00234"></a>00234             <span class="keyword">register</span> <span class="keywordtype">int</span> m =   i        &amp; 0x007fffff;
<a name="l00235"></a>00235         
<a name="l00236"></a>00236             <span class="keywordflow">if</span> (e &lt;= 0)
<a name="l00237"></a>00237             {
<a name="l00238"></a>00238                 <span class="keywordflow">if</span> (e &lt; -10)
<a name="l00239"></a>00239                 {
<a name="l00240"></a>00240                     <span class="keywordflow">return</span> 0;
<a name="l00241"></a>00241                 }
<a name="l00242"></a>00242                 m = (m | 0x00800000) &gt;&gt; (1 - e);
<a name="l00243"></a>00243         
<a name="l00244"></a>00244                 <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a><span class="keyword">&gt;</span>(s | (m &gt;&gt; 13));
<a name="l00245"></a>00245             }
<a name="l00246"></a>00246             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (e == 0xff - (127 - 15))
<a name="l00247"></a>00247             {
<a name="l00248"></a>00248                 <span class="keywordflow">if</span> (m == 0) <span class="comment">// Inf</span>
<a name="l00249"></a>00249                 {
<a name="l00250"></a>00250                     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a><span class="keyword">&gt;</span>(s | 0x7c00);
<a name="l00251"></a>00251                 } 
<a name="l00252"></a>00252                 <span class="keywordflow">else</span>    <span class="comment">// NAN</span>
<a name="l00253"></a>00253                 {
<a name="l00254"></a>00254                     m &gt;&gt;= 13;
<a name="l00255"></a>00255                     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a><span class="keyword">&gt;</span>(s | 0x7c00 | m | (m == 0));
<a name="l00256"></a>00256                 }
<a name="l00257"></a>00257             }
<a name="l00258"></a>00258             <span class="keywordflow">else</span>
<a name="l00259"></a>00259             {
<a name="l00260"></a>00260                 <span class="keywordflow">if</span> (e &gt; 30) <span class="comment">// Overflow</span>
<a name="l00261"></a>00261                 {
<a name="l00262"></a>00262                     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a><span class="keyword">&gt;</span>(s | 0x7c00);
<a name="l00263"></a>00263                 }
<a name="l00264"></a>00264         
<a name="l00265"></a>00265                 <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a><span class="keyword">&gt;</span>(s | (e &lt;&lt; 10) | (m &gt;&gt; 13));
<a name="l00266"></a>00266             }
<a name="l00267"></a>00267         }
<a name="l00268"></a>00268         
<a name="l00273"></a><a class="code" href="classOgre_1_1Bitwise.html#abb3cbaa74865420859ba7b1061f8d3f3">00273</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1Bitwise.html#abb3cbaa74865420859ba7b1061f8d3f3" title="Convert a float16 (NV_half_float) to a float32 Courtesy of OpenEXR.">halfToFloat</a>(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> y)
<a name="l00274"></a>00274         {
<a name="l00275"></a>00275             <span class="keyword">union </span>{ <span class="keywordtype">float</span> f; <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> i; } v;
<a name="l00276"></a>00276             v.i = <a class="code" href="classOgre_1_1Bitwise.html#a7ccd62b11c082f76d4972e27896c6028" title="Converts a half in uint16 format to a float in uint32 format.">halfToFloatI</a>(y);
<a name="l00277"></a>00277             <span class="keywordflow">return</span> v.f;
<a name="l00278"></a>00278         }
<a name="l00282"></a><a class="code" href="classOgre_1_1Bitwise.html#a7ccd62b11c082f76d4972e27896c6028">00282</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1Bitwise.html#a7ccd62b11c082f76d4972e27896c6028" title="Converts a half in uint16 format to a float in uint32 format.">halfToFloatI</a>(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> y)
<a name="l00283"></a>00283         {
<a name="l00284"></a>00284             <span class="keyword">register</span> <span class="keywordtype">int</span> s = (y &gt;&gt; 15) &amp; 0x00000001;
<a name="l00285"></a>00285             <span class="keyword">register</span> <span class="keywordtype">int</span> e = (y &gt;&gt; 10) &amp; 0x0000001f;
<a name="l00286"></a>00286             <span class="keyword">register</span> <span class="keywordtype">int</span> m =  y        &amp; 0x000003ff;
<a name="l00287"></a>00287         
<a name="l00288"></a>00288             <span class="keywordflow">if</span> (e == 0)
<a name="l00289"></a>00289             {
<a name="l00290"></a>00290                 <span class="keywordflow">if</span> (m == 0) <span class="comment">// Plus or minus zero</span>
<a name="l00291"></a>00291                 {
<a name="l00292"></a>00292                     <span class="keywordflow">return</span> s &lt;&lt; 31;
<a name="l00293"></a>00293                 }
<a name="l00294"></a>00294                 <span class="keywordflow">else</span> <span class="comment">// Denormalized number -- renormalize it</span>
<a name="l00295"></a>00295                 {
<a name="l00296"></a>00296                     <span class="keywordflow">while</span> (!(m &amp; 0x00000400))
<a name="l00297"></a>00297                     {
<a name="l00298"></a>00298                         m &lt;&lt;= 1;
<a name="l00299"></a>00299                         e -=  1;
<a name="l00300"></a>00300                     }
<a name="l00301"></a>00301         
<a name="l00302"></a>00302                     e += 1;
<a name="l00303"></a>00303                     m &amp;= ~0x00000400;
<a name="l00304"></a>00304                 }
<a name="l00305"></a>00305             }
<a name="l00306"></a>00306             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (e == 31)
<a name="l00307"></a>00307             {
<a name="l00308"></a>00308                 <span class="keywordflow">if</span> (m == 0) <span class="comment">// Inf</span>
<a name="l00309"></a>00309                 {
<a name="l00310"></a>00310                     <span class="keywordflow">return</span> (s &lt;&lt; 31) | 0x7f800000;
<a name="l00311"></a>00311                 }
<a name="l00312"></a>00312                 <span class="keywordflow">else</span> <span class="comment">// NaN</span>
<a name="l00313"></a>00313                 {
<a name="l00314"></a>00314                     <span class="keywordflow">return</span> (s &lt;&lt; 31) | 0x7f800000 | (m &lt;&lt; 13);
<a name="l00315"></a>00315                 }
<a name="l00316"></a>00316             }
<a name="l00317"></a>00317         
<a name="l00318"></a>00318             e = e + (127 - 15);
<a name="l00319"></a>00319             m = m &lt;&lt; 13;
<a name="l00320"></a>00320         
<a name="l00321"></a>00321             <span class="keywordflow">return</span> (s &lt;&lt; 31) | (e &lt;&lt; 23) | m;
<a name="l00322"></a>00322         }
<a name="l00323"></a>00323          
<a name="l00324"></a>00324 
<a name="l00325"></a>00325     };
<a name="l00329"></a>00329 }
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
